<template>
  <div
    style="min-width: 200px; min-height:200px;"
    :style="'height:' + height + 'px'"
    ref="chart"
  />
</template>
<script>
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
am4core.useTheme(am4themes_animated);
export default {
  name: "Component-PieChart",
  props: {
    height: {
      required: false,
      default: 205,
      type: [Number, String],
    },
    data: {
      required: true,
      default() {
        return {
          title: null,
          total: 0,
          color: null,
          values: [],
        };
      },
      type: Object,
    },
  },
  data() {
    return {
      chart: null,
    };
  },
  watch: {
    values(val) {
      if (val) {
        this.renderChart();
      }
    },
  },
  computed: {
    values() {
      return this.data.values;
    },
  },
  methods: {
    buildChart() {
      let chart = this.chart;
      chart.logo.dom.remove();
      chart.hiddenState.properties.opacity = 0;
      chart.innerRadius = am4core.percent(50);
      if (!this.data.values || this.data.values.length == 0) {
        chart.data = [
          {
            label: "Dummy",
            disabled: true,
            value: 100,
            color: am4core.color("#dadada"),
            opacity: 0.3,
            strokeDasharray: "4,4",
            tooltip: "",
          },
        ];
      } else {
        chart.data = this.data.values;
      }

      // Add and configure Series
      let series = chart.series.push(new am4charts.PieSeries());
      series.dataFields.value = "value";
      series.dataFields.category = "label";
      series.labels.template.disabled = true;
      series.ticks.template.disabled = true;
      series.labels.template.disabled = true;
      let slice = series.slices.template;
      slice.propertyFields.fill = "color";
      slice.showTooltipOn = "none";
      slice.states.getKey("hover").properties.scale = 1;
      slice.states.getKey("active").properties.shiftRadius = 0;
      slice.strokeWidth = 3;
      slice.stroke = new am4core.InterfaceColorSet().getFor("background");
      slice.strokeOpacity = 1;

      let self = this;
      chart.events.on("ready", function(event) {
        series.dataItems.each(function(row, i) {
          let rounded = Math.round(row.values.value.percent * 100) / 100;
          let fixed = parseFloat(parseFloat(rounded).toFixed(1));
          //self.data.values[i].porcentaje = fixed;
        });
      });

      if (!this.data.values || this.data.values.length == 0) {
        /* Set tup slice appearance */
        slice.propertyFields.fill = "color";
        slice.propertyFields.fillOpacity = "opacity";
        slice.propertyFields.stroke = "color";
        slice.propertyFields.strokeDasharray = "strokeDasharray";
        slice.propertyFields.tooltipText = "tooltip";
      }

      if (this.data.values && this.data.values.length > 0) {
        var label = series.createChild(am4core.Label);
        label.text = "{values.value.sum}";
        label.fontSize = 35;
        label.y = 10;
        label.fontFamily = "Avenir_Next_Demi_Bold";
        label.horizontalCenter = "middle";
        label.verticalCenter = "bottom";

        var label1 = series.createChild(am4core.Label);
        label1.wrap = true;
        label1.maxWidth = 70;
        label1.text = " Puntos de venta";
        label1.fontSize = 16;
        label1.y = 20;
        label1.textAlign = "middle";
        label1.fontFamily = "Avenir_Next_Demi_Bold";
        label1.horizontalCenter = "middle";
        label1.verticalCenter = "middle";
      }
    },
    renderChart() {
      this.$nextTick(() => {
        this.disposeChart();
        let chart = this.$refs.chart;
        this.chart = am4core.create(chart, am4charts.PieChart);
        this.buildChart();
      });
    },
    disposeChart() {
      if (this.chart) {
        this.chart.dispose();
      }
    },
  },
  beforeDestroy() {
    this.disposeChart();
  },
  mounted() {
    if (!this.chart) {
      this.renderChart();
    }
  },
};
</script>
